#ifndef _OCTREE_H_
#define _OCTREE_H_


//////////////////////////////////////////////////////////////////////////////
// Includes

#include "util/linear.h"

template<int N>
class SimplicialComplex;
class Tet;


//////////////////////////////////////////////////////////////////////////////
// class Octree

class Octree
{
public:
    Octree( const SimplicialComplex<3> *sc );
    ~Octree();

    Tet Locate( const vec3& point );

private:
    // copying disabled
    Octree( const Octree & );
    Octree& operator=( const Octree & );

    void Build( void );

    class OctNode *m_root;
    const SimplicialComplex<3> *sc;
};


#endif // _OCTREE_H_
